SeExpr

Public Member Functions | Public Attributes | Private Attributes | List of all members
SeExpr2::Expressions Class Reference

`#include <ExprMultiExpr.h>`

## Public Member Functions
| Expressions ()
| ~Expressions ()
VariableHandle | addExternalVariable (const std::string &variableName, ExprType seTy)
ExprHandle | addExpression (const std::string &varName, ExprType seTy, const std::string &expr)
VariableSetHandle | getLoopVarSetHandle (VariableHandle vh)
void | setLoopVariable (VariableSetHandle handle, double *values, unsigned dim)
void | setLoopVariable (VariableSetHandle handle, double value)
void | setLoopVariable (VariableSetHandle handle, const char *values)
void | setVariable (VariableHandle handle, double *values, unsigned dim)
void | setVariable (VariableHandle handle, double value)
void | setVariable (VariableHandle handle, const char *values)
bool | isValid () const
void | getErrors (std::vector< std::string > &errors) const
ExprEvalHandle | getExprEvalHandle (ExprHandle eh)
const std::vector< double > & | evalFP (ExprEvalHandle eeh)
const char * | evalStr (ExprEvalHandle eeh)
void | resetEval ()
void | reset ()

## Public Attributes
std::set< DExpression * > | AllExprs
std::set< GlobalVal * > | AllExternalVars

## Private Attributes
std::set< DExpression * > | exprToEval
std::set< DExpression * > | exprEvaled

## Detailed Description

Definition at line 49 of file ExprMultiExpr.h.

## Constructor & Destructor Documentation

## ◆ Expressions()

SeExpr2::Expressions::Expressions | ( |  | ) |
| inline

Definition at line 58 of file ExprMultiExpr.h.

## ◆ ~Expressions()

SeExpr2::Expressions::~Expressions | ( |  | ) |

Definition at line 145 of file ExprMultiExpr.cpp.

References AllExprs, and AllExternalVars.

## Member Function Documentation

## ◆ addExpression()

ExprHandle SeExpr2::Expressions::addExpression | ( | const std::string & | varName,
|  | ExprType | seTy,
|  | const std::string & | expr
| ) |  |

Definition at line 164 of file ExprMultiExpr.cpp.

References AllExprs, and expr().

## ◆ addExternalVariable()

VariableHandle SeExpr2::Expressions::addExternalVariable | ( | const std::string & | variableName,
|  | ExprType | seTy
| ) |  |

Definition at line 151 of file ExprMultiExpr.cpp.

References AllExternalVars, SeExpr2::ExprType::dim(), SeExpr2::ExprType::isFP(), and SeExpr2::ExprType::isString().

## ◆ evalFP()

const std::vector< double > & SeExpr2::Expressions::evalFP | ( | ExprEvalHandle | eeh | ) |

Definition at line 251 of file ExprMultiExpr.cpp.

References SeExpr2::GlobalFP::val.

## ◆ evalStr()

const char * SeExpr2::Expressions::evalStr | ( | ExprEvalHandle | eeh | ) |

Definition at line 263 of file ExprMultiExpr.cpp.

References SeExpr2::GlobalStr::val.

## ◆ getErrors()

void SeExpr2::Expressions::getErrors | ( | std::vector< std::string > & | errors | ) | const

## ◆ getExprEvalHandle()

ExprEvalHandle SeExpr2::Expressions::getExprEvalHandle | ( | ExprHandle | eh | ) |

Definition at line 228 of file ExprMultiExpr.cpp.

References exprEvaled, exprToEval, and it.

## ◆ getLoopVarSetHandle()

VariableSetHandle SeExpr2::Expressions::getLoopVarSetHandle | ( | VariableHandle | vh | ) |

Definition at line 170 of file ExprMultiExpr.cpp.

References AllExternalVars, exprToEval, and SeExpr2::GlobalVal::users.

## ◆ isValid()

bool SeExpr2::Expressions::isValid | ( |  | ) | const

Definition at line 221 of file ExprMultiExpr.cpp.

References AllExprs.

## ◆ reset()

void SeExpr2::Expressions::reset | ( |  | ) |
| inline

Definition at line 86 of file ExprMultiExpr.h.

References AllExprs, AllExternalVars, and resetEval().

## ◆ resetEval()

void SeExpr2::Expressions::resetEval | ( |  | ) |
| inline

Definition at line 81 of file ExprMultiExpr.h.

References exprEvaled, and exprToEval.

Referenced by reset().

## ◆ setLoopVariable() [1/3]

void SeExpr2::Expressions::setLoopVariable | ( | VariableSetHandle | handle,
|  | const char * | values
| ) |  |

Definition at line 191 of file ExprMultiExpr.cpp.

References AllExternalVars, and SeExpr2::GlobalStr::val.

## ◆ setLoopVariable() [2/3]

void SeExpr2::Expressions::setLoopVariable | ( | VariableSetHandle | handle,
|  | double * | values,
|  | unsigned | dim
| ) |  |

Definition at line 181 of file ExprMultiExpr.cpp.

References AllExternalVars, and SeExpr2::GlobalFP::val.

## ◆ setLoopVariable() [3/3]

void SeExpr2::Expressions::setLoopVariable | ( | VariableSetHandle | handle,
|  | double | value
| ) |  |
| inline

Definition at line 66 of file ExprMultiExpr.h.

References setLoopVariable(), and value().

Referenced by setLoopVariable().

## ◆ setVariable() [1/3]

void SeExpr2::Expressions::setVariable | ( | VariableHandle | handle,
|  | const char * | values
| ) |  |

Definition at line 211 of file ExprMultiExpr.cpp.

References SeExpr2::GlobalStr::val.

## ◆ setVariable() [2/3]

void SeExpr2::Expressions::setVariable | ( | VariableHandle | handle,
|  | double * | values,
|  | unsigned | dim
| ) |  |

Definition at line 199 of file ExprMultiExpr.cpp.

References SeExpr2::GlobalFP::val.

## ◆ setVariable() [3/3]

void SeExpr2::Expressions::setVariable | ( | VariableHandle | handle,
|  | double | value
| ) |  |
| inline

Definition at line 70 of file ExprMultiExpr.h.

References setVariable(), and value().

Referenced by setVariable().

## Member Data Documentation

## ◆ AllExprs

std::set<DExpression*> SeExpr2::Expressions::AllExprs

Definition at line 54 of file ExprMultiExpr.h.

Referenced by addExpression(), isValid(), reset(), and ~Expressions().

## ◆ AllExternalVars

std::set<GlobalVal*> SeExpr2::Expressions::AllExternalVars

Definition at line 55 of file ExprMultiExpr.h.

Referenced by addExternalVariable(), getLoopVarSetHandle(), reset(), setLoopVariable(), and ~Expressions().

## ◆ exprEvaled

std::set<DExpression*> SeExpr2::Expressions::exprEvaled
| private

Definition at line 51 of file ExprMultiExpr.h.

Referenced by getExprEvalHandle(), and resetEval().

## ◆ exprToEval

std::set<DExpression*> SeExpr2::Expressions::exprToEval
| private

Definition at line 50 of file ExprMultiExpr.h.

Referenced by getExprEvalHandle(), getLoopVarSetHandle(), and resetEval().

The documentation for this class was generated from the following files:

- /build/seexpr/src/SeExpr/src/SeExpr2/ExprMultiExpr.h
- /build/seexpr/src/SeExpr/src/SeExpr2/ExprMultiExpr.cpp